// TileEditorView.cpp : CTileEditorView Ŭ 
//

#include "stdafx.h"
#include "TileEditor.h"

#include "TileEditorDoc.h"
#include "TileEditorView.h"

#include "tile.h"
#include ".\tileeditorview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTileEditorView

IMPLEMENT_DYNCREATE(CTileEditorView, CView)

BEGIN_MESSAGE_MAP(CTileEditorView, CView)
	// ǥ μ Դϴ.
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
END_MESSAGE_MAP()

// CTileEditorView /Ҹ

CTileEditorView::CTileEditorView()
{
	// TODO: ⿡  ڵ带 ߰մϴ.

}

CTileEditorView::~CTileEditorView()
{
}

BOOL CTileEditorView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: CREATESTRUCT cs Ͽ ⿡
	// Window Ŭ Ǵ Ÿ մϴ.

	return CView::PreCreateWindow(cs);
}

// CTileEditorView ׸

void CTileEditorView::OnDraw(CDC* pDC)
{
	CTileEditorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	CTileMgr::GetInstance().DrawDC( pDC );
}


// CTileEditorView μ

BOOL CTileEditorView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ⺻ غ
	return DoPreparePrinting(pInfo);
}

void CTileEditorView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: μϱ  ߰ ʱȭ ۾ ߰մϴ.
}

void CTileEditorView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: μ   ۾ ߰մϴ.
}


// CTileEditorView 

#ifdef _DEBUG
void CTileEditorView::AssertValid() const
{
	CView::AssertValid();
}

void CTileEditorView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTileEditorDoc* CTileEditorView::GetDocument() const // ׵   ζ ˴ϴ.
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTileEditorDoc)));
	return (CTileEditorDoc*)m_pDocument;
}
#endif //_DEBUG


// CTileEditorView ޽ ó

void CTileEditorView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	CView::OnLButtonDown(nFlags, point);
}

void CTileEditorView::OnLButtonUp(UINT nFlags, CPoint point)
{
	CTileMgr::GetInstance().PickEx( point );
	CTileMgr::GetInstance().ChkSide();
	Invalidate();

	CView::OnLButtonUp(nFlags, point);
}

void CTileEditorView::OnMouseMove(UINT nFlags, CPoint point)
{
	if( nFlags == MK_LBUTTON )
	{
		CTileMgr::GetInstance().PickEx( point );
		CTileMgr::GetInstance().ChkSide();
		Invalidate();
	}

	CView::OnMouseMove(nFlags, point);
}

void CTileEditorView::OnRButtonDown(UINT nFlags, CPoint point)
{
	CTileMgr::GetInstance().AllClearTileIdx();
	Invalidate();

	CView::OnRButtonDown(nFlags, point);
}
